diff --git a/doc/guides/nics/features/sssnic.ini b/doc/guides/nics/features/sssnic.ini
index 020a9e7056..a40b509558 100644
--- a/doc/guides/nics/features/sssnic.ini
+++ b/doc/guides/nics/features/sssnic.ini
@@ -26,6 +26,7 @@ Inner L4 checksum    = Y
 Basic stats          = Y
 Extended stats       = Y
 Stats per queue      = Y
+FW version           = Y
 Linux                = Y
 ARMv8                = Y
 x86-64               = Y
diff --git a/drivers/net/sssnic/base/sssnic_api.c b/drivers/net/sssnic/base/sssnic_api.c
index 32b24e841c..12aca16995 100644
--- a/drivers/net/sssnic/base/sssnic_api.c
+++ b/drivers/net/sssnic/base/sssnic_api.c
@@ -1497,3 +1497,39 @@ sssnic_rss_indir_table_get(struct sssnic_hw *hw, uint16_t *entry,
 	sssnic_ctrlq_cmd_destroy(hw, cmd);
 	return ret;
 }
+
+int
+sssnic_fw_version_get(struct sssnic_hw *hw, struct sssnic_fw_version *version)
+{
+	int ret;
+	struct sssnic_msg msg;
+	struct sssnic_fw_version_get_cmd cmd;
+	uint32_t cmdlen = sizeof(cmd);
+	int len;
+
+	memset(&cmd, 0, sizeof(cmd));
+	cmd.type = 1; /* get MPU firmware version */
+
+	sssnic_msg_init(&msg, (uint8_t *)&cmd, cmdlen,
+		SSSNIC_GET_FW_VERSION_CMD, SSSNIC_MPU_FUNC_IDX,
+		SSSNIC_COMM_MODULE, SSSNIC_MSG_TYPE_REQ);
+	ret = sssnic_mbox_send(hw, &msg, (uint8_t *)&cmd, &cmdlen, 0);
+	if (ret != 0) {
+		PMD_DRV_LOG(ERR, "Failed to send mbox message, ret=%d", ret);
+		return ret;
+	}
+
+	if (cmdlen == 0 || cmd.common.status != 0) {
+		PMD_DRV_LOG(ERR,
+			"Bad response to SSSNIC_GET_FW_VERSION_CMD, len=%u, status=%u",
+			cmdlen, cmd.common.status);
+		return -EIO;
+	}
+
+	len = RTE_MIN(sizeof(version->version), sizeof(cmd.version));
+	rte_memcpy(version->version, cmd.version, len);
+	len = RTE_MIN(sizeof(version->time), sizeof(cmd.time));
+	rte_memcpy(version->time, cmd.time, len);
+
+	return 0;
+}
diff --git a/drivers/net/sssnic/base/sssnic_api.h b/drivers/net/sssnic/base/sssnic_api.h
index 1d80b93e38..bd4f01d388 100644
--- a/drivers/net/sssnic/base/sssnic_api.h
+++ b/drivers/net/sssnic/base/sssnic_api.h
@@ -402,6 +402,13 @@ enum sssnic_rss_hash_engine_type {
 	SSSNIC_RSS_HASH_ENGINE_COUNT,
 };
 
+#define SSSNIC_FW_VERSION_LEN 16
+#define SSSNIC_FW_TIME_LEN 20
+struct sssnic_fw_version {
+	char version[SSSNIC_FW_VERSION_LEN];
+	char time[SSSNIC_FW_VERSION_LEN];
+};
+
 int sssnic_msix_attr_get(struct sssnic_hw *hw, uint16_t msix_idx,
 	struct sssnic_msix_attr *attr);
 int sssnic_msix_attr_set(struct sssnic_hw *hw, uint16_t msix_idx,
@@ -456,5 +463,7 @@ int sssnic_rss_indir_table_set(struct sssnic_hw *hw, const uint16_t *entry,
 	uint32_t num_entries);
 int sssnic_rss_indir_table_get(struct sssnic_hw *hw, uint16_t *entry,
 	uint32_t num_entries);
+int sssnic_fw_version_get(struct sssnic_hw *hw,
+	struct sssnic_fw_version *version);
 
 #endif /* _SSSNIC_API_H_ */
diff --git a/drivers/net/sssnic/base/sssnic_cmd.h b/drivers/net/sssnic/base/sssnic_cmd.h
index 56818471b6..9da07770b1 100644
--- a/drivers/net/sssnic/base/sssnic_cmd.h
+++ b/drivers/net/sssnic/base/sssnic_cmd.h
@@ -406,4 +406,12 @@ struct sssnic_rss_indir_table_cmd {
 	uint16_t entry[256];
 };
 
+struct sssnic_fw_version_get_cmd {
+	struct sssnic_cmd_common common;
+	uint16_t type;
+	uint16_t resvd;
+	uint8_t version[16];
+	uint8_t time[20];
+};
+
 #endif /* _SSSNIC_CMD_H_ */
diff --git a/drivers/net/sssnic/sssnic_ethdev.c b/drivers/net/sssnic/sssnic_ethdev.c
index 104149b1e7..b83ee93e6c 100644
--- a/drivers/net/sssnic/sssnic_ethdev.c
+++ b/drivers/net/sssnic/sssnic_ethdev.c
@@ -740,6 +740,25 @@ sssnic_ethdev_mtu_set(struct rte_eth_dev *ethdev, uint16_t mtu)
 	return sssnic_ethdev_tx_max_size_set(ethdev, mtu);
 }
 
+static int
+sssnic_ethdev_fw_version_get(struct rte_eth_dev *ethdev, char *fw_version,
+	size_t fw_size)
+{
+	struct sssnic_hw *hw = SSSNIC_ETHDEV_TO_HW(ethdev);
+	struct sssnic_fw_version version;
+	int ret;
+
+	ret = sssnic_fw_version_get(hw, &version);
+	if (ret) {
+		PMD_DRV_LOG(ERR, "Failed to get firmware version");
+		return ret;
+	}
+
+	snprintf(fw_version, fw_size, "%s", version.version);
+
+	return 0;
+}
+
 static const struct eth_dev_ops sssnic_ethdev_ops = {
 	.dev_start = sssnic_ethdev_start,
 	.dev_stop = sssnic_ethdev_stop,
@@ -780,6 +799,7 @@ static const struct eth_dev_ops sssnic_ethdev_ops = {
 	.mtu_set = sssnic_ethdev_mtu_set,
 	.rxq_info_get = sssnic_ethdev_rx_queue_info_get,
 	.txq_info_get = sssnic_ethdev_tx_queue_info_get,
+	.fw_version_get = sssnic_ethdev_fw_version_get,
 };
 
 static int